clear; clc; tic; 

load('Data.mat'); 

%--------------------------------------------------------------------------
%                       Grid points for beta
%--------------------------------------------------------------------------
grid_1   = 0.001:0.001:0.020;                l1 = length(grid_1); 
grid_2   = 5.000:0.100:8.000;                l2 = length(grid_2);  
grid_3   = 0.950:0.001:0.999;                l3 = length(grid_3);
grid_4   = 3.000:0.100:6.000;                l4 = length(grid_4);
grid34   = [kron(grid_3', ones(l4,1))        kron(ones(l3,1),grid_4')];
grid234  = [kron(grid_2', ones(l3*l4,1))     kron(ones(l2,1),grid34)];
beta_g   = [kron(grid_1', ones(l2*l3*l4,1))  kron(ones(l1,1),grid234)];
grid134  = [kron(grid_1', ones(l3*l4,1)) kron(ones(l1,1),grid34)]; l_134 = size(grid134,1);
beta_g0  = [grid134(:,1) zeros(l_134,1), grid134(:,2:3)];
%--------------------------------------------------------------------------

step  = [.005, 0.002, 0.001];                            

for p = [0.005, 0.007, 0.009]  

%--------------------------------------------------------------------------
%          [ delta   g_c    g_d    Sig_c^2    phi    p     v      q  ]
nuisance = [  .97,   0.02,  0.02,  0.02^2,    3.5,   p,   0.07,  0.4 ]; 
%--------------------------------------------------------------------------

rng('default');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                            AP1 + AP3
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if     p == 0.005; bound = [-.025,.025;-.050,.055];  
    
elseif p == 0.007; bound = [-.025,.025;-.055,.055];  
    
elseif p == 0.009; bound = [-.025,.025;-.060,.050];  

end


type_CS = [1 3];

d1   = bound(1,1):step(1):bound(1,2);                   l_d1  = size(d1,2);
d2   = bound(2,1):step(1):bound(2,2);                   l_d2  = size(d2,2);
d12  = [kron(d1',ones(l_d2,1)) kron(ones(l_d1,1),d2')]; l_d12 = size(d12,1);

delta_g0               = zeros(l_d12,6);
delta_g0(:,type_CS(1)) = d12(:,1);
delta_g0(:,type_CS(2)) = d12(:,2);
delta_g{1}             = delta_g0;

for j = 1:length(step)

    [CI_J{j}, CI_cc{j}] = CS_0(Data,nuisance,delta_g{j},type_CS,beta_g,beta_g0);

    if j < length(step)

        dist_cr = step(j)*sqrt(2);

        d12 = Exd_CS_g(CI_J{j},CI_cc{j},dist_cr,bound,step(j+1));

        delta_g0               = zeros(size(d12,1),6);
        delta_g0(:,type_CS(1)) = d12(:,1);
        delta_g0(:,type_CS(2)) = d12(:,2);
        delta_g{j+1}           = delta_g0;

    end

end

toc

CI13_J   = [CI_J{1};    CI_J{2};    CI_J{3}];
CI13_cc  = [CI_cc{1};   CI_cc{2};   CI_cc{3}];
points13 = [delta_g{1}; delta_g{2}; delta_g{3}];
points13 = [points13(:,type_CS(1)) points13(:,type_CS(2))];

name = 'CS13_p%d.mat';

save(sprintf(name,p*1000),'CI13_J','CI13_cc','points13');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                            AP3 + AP4
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if     p == 0.005; bound = [-.050,.055;-.035,.025];  

elseif p == 0.007; bound = [-.070,.050;-.055,.025]; 
    
elseif p == 0.009; bound = [-.090,.040;-.075,.020]; 

end

type_CS = [3 4];
  
d1  = bound(1,1):step(1):bound(1,2);                   l_d1  = size(d1,2);
d2  = bound(2,1):step(1):bound(2,2);                   l_d2  = size(d2,2);
d12 = [kron(d1',ones(l_d2,1)) kron(ones(l_d1,1),d2')]; l_d12 = size(d12,1);

delta_g0               = zeros(l_d12,6);
delta_g0(:,type_CS(1)) = d12(:,1);
delta_g0(:,type_CS(2)) = d12(:,2);
delta_g{1}             = delta_g0;

for j = 1:length(step)

    [CI_J{j}, CI_cc{j}] = CS_0(Data,nuisance,delta_g{j},type_CS,beta_g,beta_g0);

    if j < length(step)

        dist_cr = step(j)*sqrt(2);

        d12 = Exd_CS_g(CI_J{j},CI_cc{j},dist_cr,bound,step(j+1));

        delta_g0 = zeros(size(d12,1),6);
        delta_g0(:,type_CS(1)) = d12(:,1);
        delta_g0(:,type_CS(2)) = d12(:,2);
        delta_g{j+1} = delta_g0;

    end

end

toc

CI34_J   = [CI_J{1}; CI_J{2}; CI_J{3}]; 
CI34_cc  = [CI_cc{1};CI_cc{2};CI_cc{3}];
points34 = [delta_g{1};delta_g{2};delta_g{3}];
points34 = [points34(:,type_CS(1)) points34(:,type_CS(2))];
  
name = 'CS34_p%d.mat';

save(sprintf(name,p*1000),'CI34_J','CI34_cc','points34');

end

%--------------------------------------------------------------------------
%                 Add more points to CS13_P7 
%--------------------------------------------------------------------------
clear; clc; tic; load('Data.mat'); 
%--------------------------------------------------------------------------
%                       Grid points for beta
%--------------------------------------------------------------------------
grid_1   = 0.001:0.001:0.020;                l1 = length(grid_1); 
grid_2   = 5.000:0.100:8.000;                l2 = length(grid_2);  
grid_3   = 0.950:0.001:0.999;                l3 = length(grid_3);
grid_4   = 3.000:0.100:6.000;                l4 = length(grid_4);
grid34   = [kron(grid_3', ones(l4,1))        kron(ones(l3,1),grid_4')];
grid234  = [kron(grid_2', ones(l3*l4,1))     kron(ones(l2,1),grid34)];
beta_g   = [kron(grid_1', ones(l2*l3*l4,1))  kron(ones(l1,1),grid234)];
grid134  = [kron(grid_1', ones(l3*l4,1)) kron(ones(l1,1),grid34)]; l_134 = size(grid134,1);
beta_g0  = [grid134(:,1) zeros(l_134,1), grid134(:,2:3)];
%--------------------------------------------------------------------------

step  = 0.001;  

p     = 0.007;  

bound = [-.010,-0.008;.003,.011];  

%--------------------------------------------------------------------------
%          [ delta   g_c    g_d    Sig_c    phi    p     v      q  ]
nuisance = [  .97,   0.02,  0.02,  0.02^2,  3.5,   p,   0.07,  0.4 ]; 
%--------------------------------------------------------------------------

rng('default');

type_CS = [1 3];

d1   = bound(1,1):step(1):bound(1,2);                   l_d1  = size(d1,2);
d2   = bound(2,1):step(1):bound(2,2);                   l_d2  = size(d2,2);
d12  = [kron(d1',ones(l_d2,1)) kron(ones(l_d1,1),d2')]; l_d12 = size(d12,1);

delta_g0               = zeros(l_d12,6);
delta_g0(:,type_CS(1)) = d12(:,1);
delta_g0(:,type_CS(2)) = d12(:,2);
delta_g{1}             = delta_g0;

for j = 1:length(step)

    [CI_J{j}, CI_cc{j}] = CS_0(Data,nuisance,delta_g{j},type_CS,beta_g,beta_g0);

    if j < length(step)

        dist_cr = step(j)*sqrt(2);

        d12 = Exd_CS_g(CI_J{j},CI_cc{j},dist_cr,bound,step(j+1));

        delta_g0               = zeros(size(d12,1),6);
        delta_g0(:,type_CS(1)) = d12(:,1);
        delta_g0(:,type_CS(2)) = d12(:,2);
        delta_g{j+1}           = delta_g0;

    end

end

CI_J_a    = CI_J{1};
CI_cc_a   = CI_cc{1};
delta_g_a = delta_g{1};
delta_g_a = [delta_g_a(:,type_CS(1)) delta_g_a(:,type_CS(2))];

load('CS13_p7.mat')

CI13_J   = [CI13_J;    CI_J_a   ];
CI13_cc  = [CI13_cc;   CI_cc_a  ];
points13 = [points13;  delta_g_a];

toc

name = 'CS13_p%d.mat';

save(sprintf(name,p*1000),'CI13_J','CI13_cc','points13');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     Function used to find the set of unrejected sets by J and CC
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [CI_J, CI_cc] = CS_0(Data, nuisance, delta_g, type_CS, beta_g, beta_g0)
%--------------------------------------------------------------------------
% Data:      data set
% nuisance:  calibrated parameters
% delta_g:   the grid points of delta to be tested
% type_CS:   the index of the AP moments to be tested
% theta_g:   grid points of reparametrized theta (i.e., beta)
% theta_g0:  grid points of theta_0 in baseline
%--------------------------------------------------------------------------
l_g     = size(delta_g,1);

J_test  = zeros(l_g,1);

cc_test = zeros(l_g,1); 

for j = 1:l_g

    H0 = delta_g(j,:);
 
    [cue_est, omg, pval_J, G, J] = gmm_cue(Data, nuisance, H0, beta_g);
 
    [~,C_test] = conditional_inference(Data, nuisance, H0, beta_g0, cue_est, omg, G, J); 
 
    if pval_J  < 0.05; J_test(j,1)  = 1; end
 
    cc_test(j,1) = C_test;

end

CI_J  = delta_g(:,type_CS); loc = (J_test == 1);  CI_J(loc,:)  = [];

CI_cc = delta_g(:,type_CS); loc = (cc_test == 1); CI_cc(loc,:) = [];

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    Function used to locate the grid points on the boundary of a set
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function f = Exd_CS_g(CI_J0, CI_cc0, dist_cr, bound, step)
%--------------------------------------------------------------------------
% CI_J0:   the preliminary set from J test
% CI_cc0:  the preliminary set from CC test
% dist_cr: the distance one wants to explore beyond the boundary
% bound:   the parameter space for delta
% step:    the stepsize
%--------------------------------------------------------------------------
l_J = length(CI_J0);  l_C =  length(CI_cc0);  

d1  = bound(1,1):step:bound(1,2);                          l_d1 = size(d1,2);
d2  = bound(2,1):step:bound(2,2);                          l_d2 = size(d2,2);
delta_g = [kron(d1',ones(l_d2,1)) kron(ones(l_d1,1),d2')]; l_gd = size(delta_g,1);
 
id1 = zeros(l_gd,1);  id2 = zeros(l_gd,1);    

for j = 1:l_gd
    
    test_d = ones(l_J,1)*delta_g(j,:);
    
    dist_J   =  min((((test_d - CI_J0).^2)*ones(2,1)).^(1/2));
    
    A1 = ( test_d(:,1) > CI_J0(:,1)).*( test_d(:,2) > CI_J0(:,2));
    A2 = ( test_d(:,1) > CI_J0(:,1)).*( test_d(:,2) < CI_J0(:,2));
    A3 = ( test_d(:,1) < CI_J0(:,1)).*( test_d(:,2) > CI_J0(:,2));
    A4 = ( test_d(:,1) < CI_J0(:,1)).*( test_d(:,2) < CI_J0(:,2));
    
    if sum(A1) == 0 || sum(A2) == 0 || sum(A3) == 0 || sum(A4) == 0 
    
    id1(j,1) = 1;
    
    end
    
    if dist_J > dist_cr; id1(j,1) = 0; end
    
    test_d = ones(l_C,1)*delta_g(j,:);
    
    dist_C = min((((test_d - CI_cc0).^2)*ones(2,1)).^(1/2));
    
    A1 = ( test_d(:,1) > CI_cc0(:,1)).*( test_d(:,2) > CI_cc0(:,2));
    A2 = ( test_d(:,1) > CI_cc0(:,1)).*( test_d(:,2) < CI_cc0(:,2));
    A3 = ( test_d(:,1) < CI_cc0(:,1)).*( test_d(:,2) > CI_cc0(:,2));
    A4 = ( test_d(:,1) < CI_cc0(:,1)).*( test_d(:,2) < CI_cc0(:,2));
    
    if sum(A1) == 0 || sum(A2) == 0 || sum(A3) == 0 || sum(A4) == 0 
    
    id2(j,1) = 1;
    
    end
    
    if dist_C > dist_cr; id2(j,1) = 0; end
       
end

loc_J   = (id1 == 1); grid_J = delta_g(loc_J,:);
loc_C   = (id2 == 1); grid_C = delta_g(loc_C,:);
grid_0  = [grid_J;grid_C];
f       = unique(grid_0,'rows');

end
