clear; clc; tic; load('Data.mat'); n = size(Data,1); 

para_p    = (0.003:0.002:0.011)';
S         = size(para_p,1);

beta_est  = zeros(S,4);
theta_est = zeros(S,4);
p_val_J   = zeros(S,1);
p_val_CC  = zeros(S,1);
J_stat    = zeros(S,1);

for s = 1:S  
    
    s
    
p        = para_p(s);   

%          [ delta   g_c    g_d    Sig_c^2    phi    p     v      q  ] 
nuisance = [  .97,   0.02,  0.02,  0.02^2,    3.5,   p,   0.07,  0.4 ];

H0       = zeros(1,6); tic;

%--------------------------------------------------------------------------
%                          Grid points
%--------------------------------------------------------------------------
grid_1   = 0.001:0.001:0.020;             l1   = length(grid_1);           
grid_3   = 0.950:0.001:0.999;             l3   = length(grid_3);
grid_4   = 3.000:0.010:6.000;             l4   = length(grid_4);
grid34   = [kron(grid_3', ones(l4,1))     kron(ones(l3,1),grid_4')];
grid_2_0 = 5.000:0.010:12.00;             l2_0 = length(grid_2_0);
grid134  = [kron(grid_1', ones(l3*l4,1))  kron(ones(l1,1),grid34)]; l_134 = size(grid134,1);
beta_g0  = [grid134(:,1) zeros(l_134,1),  grid134(:,2:3)];

K_n      = 100; K = (l2_0-1)/K_n;

gmm_est  = zeros(K,4);           gmm_val  = zeros(K,1);

for k = 1:K

    i1 = 1 + (k-1)*K_n; i2 = k*K_n;

    if k == K; i2 = i2 + 1; end
    
    grid_2  = grid_2_0(1,i1:i2);                l2 = length(grid_2);
    grid234 = [kron(grid_2', ones(l3*l4,1))     kron(ones(l2,1),grid34)];
    beta_g  = [kron(grid_1', ones(l2*l3*l4,1))  kron(ones(l1,1),grid234)];

    [gmm_est(k,:), ~, ~, ~, gmm_val(k,:)] = gmm_cue(Data, nuisance, H0, beta_g);

end

[~, loc]  = min(gmm_val);  

cue_beta  = gmm_est(loc,:);

[~, omg, p_val_J(s,1), G, J] = gmm_cue(Data, nuisance, H0, cue_beta)

beta_est(s,:)  = cue_beta;

J_stat(s,:)    = J;

cue_theta(1,1) = cue_beta(:,4) + p/cue_beta(:,1);

cue_theta(1,2) = cue_beta(:,2)*(1 - cue_beta(:,3)^2);

cue_theta(1,3) = cue_beta(:,3); 

cue_theta(1,4) = cue_beta(:,4);

theta_est(s,:) = cue_theta;

toc

rng('default');

p_val_CC(s,1) = conditional_inference(Data, nuisance, H0, beta_g0, cue_beta, omg, G, J)

toc

end

name = 'J_and_CC.mat';

save(sprintf(name),'beta_est','theta_est','p_val_J','J_stat','p_val_CC');  
